package com.example.StepDefinations;

import com.example.PageObjects.HomePage;
import com.example.Utils.TextContextSetup;
import io.cucumber.datatable.DataTable;
import io.cucumber.java.en.Then;
import io.cucumber.java.en.When;

import java.util.List;
import java.util.Map;

public class HomePageSteps {

    TextContextSetup textContextSetup;

    public HomePageSteps(TextContextSetup textContextSetup) {
        this.textContextSetup = textContextSetup;
    }

    @When("I Click on About Us button on Home page")
    public void i_click_on_about_us_button_on_home_page() {
        HomePage homePage = textContextSetup.pagesObject.getHomePage();
        homePage.aboutUsButtonLocator().click();
    }

    @When("I Click On Our Timeline Button On home page")
    public void i_click_on_our_timeline_button_on_home_page() {
        HomePage homePage = textContextSetup.pagesObject.getHomePage();
        homePage.timeLineButtonLocator().click();
    }

    @When("I Click On Our contact Button On home page")
    public void i_click_on_our_contact_button_on_home_page() {
        HomePage homePage = textContextSetup.pagesObject.getHomePage();
        homePage.contactButtonLocator().click();
    }

    @When("I select a {string} feature on home page")
    public void i_select_feature(String feature) throws InterruptedException {
        HomePage homePage = textContextSetup.pagesObject.getHomePage();
        if (feature.equalsIgnoreCase("welfare")) {
            homePage.featureLocator(1).click();
            homePage.featureLearnMoreButtonLocator(feature).click();
        }
        if (feature.equalsIgnoreCase("education")) {
            homePage.featureLocator(2).click();
            homePage.featureLearnMoreButtonLocator(feature).click();
        }
        if (feature.equalsIgnoreCase("publication")) {
            homePage.featureLocator(3).click();
            homePage.featureLearnMoreButtonLocator(feature).click();
        }
        if (feature.equalsIgnoreCase("bayanat")) {
            homePage.featureLocator(4).click();
            homePage.featureLearnMoreButtonLocator(feature).click();
        }
    }

    @Then("^I should see the following bayanat on bayan page:$")
    public void i_should_see_bayanat_list(DataTable bayanList) throws InterruptedException {
        HomePage homePage = textContextSetup.pagesObject.getHomePage();
        Thread.sleep(7000);
        List<Map<String,String>> data = bayanList.asMaps(String.class,String.class);
        for (Map<String, String> itemData : data){
            homePage.bayanListLocator(itemData.get("Bayanat")).isDisplayed();
        }
    }

    @Then("^I should see the following publication on Publication page:$")
    public void i_should_see_publication_list(DataTable bayanList) throws InterruptedException {
        HomePage homePage = textContextSetup.pagesObject.getHomePage();
        Thread.sleep(7000);
        List<Map<String,String>> data = bayanList.asMaps(String.class,String.class);
        for (Map<String, String> itemData : data)
            homePage.publicationListLocator(itemData.get("Publication")).isDisplayed();
    }

    @Then("^I should see the following education projects on Education page:$")
    public void i_should_see_education_project_list(DataTable bayanList) throws InterruptedException {
        HomePage homePage = textContextSetup.pagesObject.getHomePage();
        Thread.sleep(7000);
        List<Map<String,String>> data = bayanList.asMaps(String.class,String.class);
        for (Map<String, String> itemData : data)
            homePage.educationProjectListLocator(itemData.get("Education")).isDisplayed();
    }

    @Then("^I should see the following welfare project on Welfare page:$")
    public void i_should_see_welfare_project_list(DataTable bayanList) throws InterruptedException {
        HomePage homePage = textContextSetup.pagesObject.getHomePage();
        Thread.sleep(7000);
        List<Map<String,String>> data = bayanList.asMaps(String.class,String.class);
        for (Map<String, String> itemData : data)
            homePage.welfareProjectLocator(itemData.get("Welfare Project")).isDisplayed();
    }

}


