package com.example.Utils;

import org.openqa.selenium.WebDriver;
import org.openqa.selenium.chrome.ChromeDriver;
import org.openqa.selenium.firefox.FirefoxDriver;
import org.openqa.selenium.logging.LogType;
import org.openqa.selenium.logging.LoggingPreferences;
import org.openqa.selenium.remote.CapabilityType;
import org.openqa.selenium.remote.DesiredCapabilities;

import java.io.FileInputStream;
import java.io.IOException;
import java.util.Properties;
import java.util.concurrent.TimeUnit;
import java.util.logging.Level;


public class BaseClass {

    public WebDriver driver;
    public WebDriver WebDriverManager() throws IOException {
        FileInputStream fis=new FileInputStream(System.getProperty("user.dir")+"//src//main//resources//global.properties");
        Properties prop=new Properties();
        prop.load(fis);
        String url=prop.getProperty("Url");
        String browser_properties=prop.getProperty("browser");
        String browser_maven=System.getProperty("browser");
        String browser=browser_maven!=null ?browser_maven:browser_properties;
        if(driver==null) {
            if(browser.equalsIgnoreCase("chrome"))
            {                //For chrome browser any other browser can add their
            System.setProperty("webdriver.chrome.driver", "src/main/resources/chromedriver");
                DesiredCapabilities caps = new DesiredCapabilities();
                LoggingPreferences logPrefs = new LoggingPreferences();
                logPrefs.enable(LogType.BROWSER, Level.ALL);
                caps.setCapability(CapabilityType.LOGGING_PREFS, logPrefs);
            driver = new ChromeDriver(caps);
            driver.manage().timeouts().implicitlyWait(15, TimeUnit.SECONDS);
            driver.manage().window().maximize();
            }

//            if(browser.equalsIgnoreCase("firefox"))
//          {
//              System.setProperty("webdriver.gecko.driver", "src/main/resources/geckodriver");
//              driver= new FirefoxDriver();
//              driver.manage().window().maximize();
//           }
            driver.get(url);
        }
        return driver;
    }
}
