Feature: Welfare Feature

  Background:
    When Close the popup
    And  I close the messenger popUp


  @web
  Scenario Outline: User should be able to 'Quick Donate' on welfare page
    When I select a "welfare" feature on home page
    And I select "<donation>" Donation category form dropdown on welfare page
    And I select "<Sub donation>" Sub Donation category form dropdown on welfare page
    And I fill "100" in Amount field on welfare page
    And I press "Donate"
    Then User should be redirected to "Checkout" page

    Examples:
      | donation   | Sub donation              |
      | Zakat      | Zakat General             |
      | Qurbani    | Cow-A-Share               |
      | Membership | 1000 - Monthly            |
      | Featured   | Tuhfa Test zakat          |
      | Fitra      | Fitra - Wheat (گندم)      |
      | Sadqa      | Sadqah General (Donation) |

  @web
  Scenario Outline: User should be able to 'Make A Donation' on welfare page
    When I select a "welfare" feature on home page
    And I select "Recurring" payment
    And I select "Weekly" payment
    And I select donation "<cause>" cause in 'Donation now modal' on Home page
    And I select donation "<type>" type in 'Donation now modal' on Home page
    And I Enter Donation "1000" amount
    And I press "Donate Now"
    Then I should see the "<donation>" Donation is added to the cart
    And I press "Checkout"
    Then User should be redirected to "Checkout" page


    Examples:
      | cause      | type             | donation         |
      | Zakat      | Zakat General    | Zakat General    |
      | Qurbani    | Cow-A-Share      | Cow-A-Share      |
      | Membership | 1000 - Monthly   | 1000 - Monthly   |
      | Featured   | Tuhfa Test zakat | Tuhfa Test zakat |


  @web
  Scenario Outline: User should be redirected to correct pages when selecting projects
    When I select a "welfare" feature on home page
    And I should hover on "Projects" welfare header title to select "<headerItems>" item from drop down on welfare page
    Then User should be redirected to "<pages>" page

    Examples:
      | headerItems | pages    |
      | Foodbank    | Foodbank |


  @web
  Scenario Outline: User should be redirected to correct pages when Selecting News from drop down
    When I select a "welfare" feature on home page
    And I should hover on "News" welfare header title to select "<headerItems>" item from drop down on welfare page
    Then User should be redirected to "<pages>" page

    Examples:
      | headerItems                                                                        | pages                                                                              |
      | Baitussalam Ration distribution program                                            | Baitussalam Ration distribution program                                            |
      | Do good and good will come to you!                                                 | Do good and good will come to you!                                                 |
      | Baitussalam volunteers on duty!                                                    | Baitussalam volunteers on duty!                                                    |
      | The orphan kids were succoured with food and other life necessities by Baitussalam | The orphan kids were succoured with food and other life necessities by Baitussalam |


  @web
  Scenario Outline: User should be redirected to correct pages when Selecting Images from drop down
    When I select a "welfare" feature on home page
    And I should hover on "Media" welfare header title to select "<headerItems>" item from drop down on welfare page
    Then User should be redirected to "<pages>" page

    Examples:
      | headerItems | pages   |
      | Images      | Gallery |
      | Videos      | Gallery |


  @web
  Scenario: User should be redirected to correct pages when Selecting About Us
    When I select a "welfare" feature on home page
    When I click on "About us" button on welfare page
    Then User should be redirected to "About us" page

  @web
  Scenario: User should be redirected to correct pages when Selecting Contact Us
    When I select a "welfare" feature on home page
    When I click on "Contact" button on welfare page
    Then User should be redirected to "Contact" page

  @web
  Scenario: User should be redirected to correct pages when Selecting Contribute
    When I select a "welfare" feature on home page
    When I click on "Contribute" button on welfare page
    Then User should be redirected to "Ways to Donate" page

  @web
  Scenario: User should be able to become a volunteer
    When I select a "welfare" feature on home page
    When I click on "Join Us" button on welfare page
    And I fill Volunteer information in the Become a Volunteer form with the following data on welfare Page:
      | fullName       | DateOfBirth | email             | phoneNumber | address | city       | country  | CNIC   | mobileNumber | postalCode |
      | Muhammad rahim | 2000-10-03  | test@123gmail.com | random      | karachi | xyz street | Pakistan | random | random   | 12313      |
    And I fill alternate contact information in the Become a Volunteer form with the following data on welfare Page:
      | alternateFullName | relation | alternatePhoneNumber | alternateAddress | alternateCity | alternateCountry | alternateMobileNumber | alternatePostalCode | education  |
      | Muhammad rahim    | Friend   | 12323123             | abc street       | karachi       | Pakistan         | 0312313141414         | 42233               | Graduation |
    And I fill occupation information in the Become a Volunteer form with the following data on welfare Page:
      | Occupation | typeOfEmployment | employmentName    | areaOfInterest |
      | testing    | EMPLOYED         | software engineer | field work     |
    And I fill Voluntarism Details in the Become a Volunteer form with the following data on welfare Page:
      | workExperience | workExperienceDetail         | startWorkingDate | workingHourPerDay | proficiencyInLanguage | timeDetail | monthlyAvailability | dayAvailability     | reasonForWorking          | preferredField | haveDrivingLicense | didKnownPersonWorking |
      | Yes            | 3 year of working experience | 2022-10-03       | 2                 | urdu/english          | Yes        | JUNE                | WEDNESDAY,afternoon | like to do volunteer work | xyz            | No                 | No                    |
#    <--------- Bug Voluntarism detail on click on 'No' button text Yes is selected------------>
    And I press "Submit"
    #    <--------- Bug website is crashing------------>